<?php
// PRINCIPE :
// Le script est execut par tranches afin de ne pas surcharger le serveur.
// CONFIGURATION :

// Temps d'execution maximum d'une "tranche" en secondes
$tempsExecMax = 180; //250
// Temps d'attente entre chaque "tranche" en millisecondes
$tempsRepos = 10000;

// POUR lancer le script, taper dans le navigateur [...]/pmb/admin/sauvegarde/restaure.php?filename=full_2013_01_05.sav&critical=1

//Extrait de messages_env_ract_inc.php
$msg["sauv_misc_ract_title"]="Restauration d'un jeu";
$msg["sauv_misc_ract_cant_connect"]="La connexion au serveur de base de donnes n'a pu tre tablie";
$msg["sauv_misc_ract_db_dont_exists"]="La base %s n'existe pas";
$msg["sauv_misc_ract_cant_open_file"]="Le fichier n'a pu tre ouvert !";
$msg["sauv_misc_ract_no_sauv"]="Le fichier n'est pas un fichier de sauvegarde !";
$msg["sauv_misc_ract_decryt_msg"]="Dcryptage du fichier...";
$msg["sauv_misc_ract_bad_keys"]="Vous n'avez pas fourni les bonnes clefs pour dcrypter le fichier !";
$msg["sauv_misc_ract_create"]="Le fichier SQL n'a pu tre cr, vrifiez les droits du rpertoire admin/backup/backups/";
$msg["sauv_misc_ract_decompress"]="Dcompression du fichier...";
$msg["sauv_misc_ract_not_bz2"]="Le fichier de donnes n'a pas t compress avec bz2";
$msg["sauv_misc_ract_restaure_tables"]="Restauration des tables";
$msg["sauv_misc_ract_open_failed"]="Le fichier SQL n'a pu tre ouvert";
$msg["sauv_misc_ract_restaured_t"]="Table %s restaure.";
$msg["sauv_misc_ract_start_restaure"]="Dbut de restauration de la table %s...";
$msg["sauv_misc_ract_ignore"]="Ignore la table %s ...";
$msg["sauv_misc_ract_invalid_request"]="Requte invalide : %s";
$msg["sauv_misc_ract_correct"]="La restauration s'est passe correctement";





// Repre le temps d'execution de la fonction
list($usec, $sec) = explode(' ', microtime());
$start_time=(float)$usec + (float)$sec;
$new_time = $start_time;



///////////////////////////////////////////////////////////////////////////////
/////////////////////// INITIALISATION ////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

if(empty($_POST['iteration']))
{
	// les variables ci-dessous ont t envoyes (ventuellement partiellement) par le formulaire de "restaure.php"
	// en mthode POST  (lignes ci-dessous extraites de messages_env_ract_inc.php  ne faire qu' l'init)
	$filename=$_POST["filename"];
	$compress=$_POST["compress"];
	$crypt=$_POST["crypt"];
	$tables=$_POST["tables"];
	$decompress=$_POST["decompress"];
	$decompress_ext=$_POST["decompress_ext"];
	$decompress_type=$_POST["decompress_type"];
	$phrase1=$_POST["phrase1"];
	$phrase2=$_POST["phrase2"];
	$db=$_POST["db"];
	$host=$_POST["host"];
	$db_user=$_POST["db_user"];
	$db_password=$_POST["db_password"];
	$critical=$_POST["critical"];

	$iteration = 1; // Compteur d'itrations

	
	

	//Rcupration du nom de fichier
	$tFilename=explode("/",$filename);
	$file_name=$tFilename[count($tFilename)-1];

	// Connexion  la base
	mysql_connect($host,$db_user,$db_password) or die($msg["sauv_misc_ract_cant_connect"]);
	mysql_select_db($db) or die(sprintf($msg["sauv_misc_ract_db_dont_exists"],$db));

	// Cration table de suivi de la restauration
	$cmd="drop table if exists PGS_suivi_restauration;";
	mysql_query($cmd) or die(sprintf("Erreur sur commande %s\n",$cmd)); flush();
	$cmd="CREATE TABLE IF NOT EXISTS `PGS_suivi_restauration` (   `quand` DATETIME NOT NULL, `message` varchar(255) NOT NULL ,  `ligne` int(8) unsigned NOT NULL,      `commande` varchar(512) NOT NULL) DEFAULT CHARSET=latin1;";
	mysql_query($cmd) or die(sprintf("Erreur sur commande %s\n",$cmd)); flush();


	require_once("../../classes/crypt.class.php");

	print "<div id=\"contenu-frame\">\n";
	echo "<center><h1>".sprintf($msg["sauv_misc_restaure"],$file_name)."</h1></center>\n";

	//Rcupration de la partie data
	$f=fopen($filename,"r") or die($msg["sauv_misc_ract_cant_open_file"].$filename);
	$line=fgets($f,4096);
	$line=rtrim($line);

	while ((!feof($f))&&($line!="#data-section")) {
		$line=fgets($f,4096);
		$line=rtrim($line);
	}

	if ($line!="#data-section") die($msg["sauv_misc_ract_no_sauv"]);

	/*$datas=fread($f,filesize($filename));

	fclose($f);

	//Si crypt
	if ($crypt==1) {
		echo "<b>".$msg["sauv_misc_ract_decryt_msg"]."</b><br />";
		flush();
		$c=new Crypt(md5($phrase1),md5($phrase2));
		$sign=substr($datas,0,8);
		$dSign=$c->getDecrypt($sign);
		if ($dSign!="PMBCrypt") die($msg["sauv_misc_ract_bad_keys"]);
		$datas=substr($datas,8);
		$datas=$c->getDecrypt($datas);
	}
	*/

	//Copie des donnes dans un fichier temporaire
	$tempfile="temp_restaure";
	$tempfiledest="../backup/backups/temp_restaure.sql";

	//Si compress
	if ($compress==1) {
		if ($decompress_type=="internal") $tempfile.=".bz2"; else $tempfile.=".sql.".$decompress_ext;
	} else $tempfile.=".sql";

	$tempfile="../backup/backups/".$tempfile;
	$ftemp=fopen($tempfile,"w+") or die($msg["sauv_misc_ract_create"]);

	while (!feof($f)) {
		fwrite($ftemp,fread($f,4096));
	}

	//fwrite($ftemp,$datas);
	fclose($ftemp);
	fclose($f);

	//Dcompression ventuelle
	if ($compress==1) {
		echo "<b>".$msg["sauv_misc_ract_decompress"]."</b><br />";
		flush();
		if ($decompress_type=="external") {
			$decompress=str_replace("%s",$tempfile,$decompress);
			$decompress=str_replace("%sd",$tempfiledest,$decompress);
			exec($decompress);
		} else {
			$ftempin=bzopen($tempfile,"r") or die($msg["sauv_misc_ract_not_bz2"]);
			$ftempout=fopen($tempfiledest,"w+") or die($msg["sauv_misc_ract_create"]);
			while (!feof($ftempin)) {
				$datas=bzread($ftempin,2048);
				fwrite($ftempout,$datas);
			}
			bzclose($ftempin);
			fclose($ftempout);
			@unlink($tempfile);
		}
	}


	echo "<b>".$msg["sauv_misc_ract_restaure_tables"]."</b><br /><br />";
	$start = 0; //  partir d'ici $start correspond au numro de ligne courante dans le fichier de commandes SQL tempfiledest : mettre une autre valeur pour tester plus loin que le dbut
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////// APPELS SUCCESSIFS ////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

else
{
	// APPEL  chaque fois : on rcupre les variables postes par "restaure_act.php" en mthode POST
	$iteration   = $_POST['iteration']+1;
	$start       = $_POST['start'];
	$host        = $_POST['host'];
	$db          = $_POST['db'];
	$db_user     = $_POST['db_user'];
	$db_password = $_POST['db_password'];

	echo "<h2>Reprise  la ligne ".($start+1)." (itration n$iteration qui va durer au max $tempsExecMax secondes)</h2><br>";


   // Connexion  la base
	$identifiant = mysql_connect($host,$db_user,$db_password) or die($msg["sauv_misc_ract_cant_connect"]);
	mysql_select_db($db) or die(sprintf($msg["sauv_misc_ract_db_dont_exists"],$db));


   	// Aller  la ligne o on s'est arrt prcdemment
	$tempfiledest="../backup/backups/temp_restaure.sql";
	$fsql=fopen($tempfiledest,"r") or die($msg["sauv_misc_ract_open_failed"]);
	$num_ligne = 1;
	while ((!feof($fsql))&&($num_ligne < $start)) {
		$line=fgets($fsql,4096);
		$num_ligne=$num_ligne+1;
		//echo "on passe $line<br>";
	}
    echo "<UL>";

	$cmd = "insert into PGS_suivi_restauration (quand,message,ligne,commande)  values (now(),\"Dbut itration $iteration\" ,$start,\"\")";
	mysql_query($cmd) or die(mysql_error()." sur commande : ".$cmd."<br>"); 

	
	$currentTable="";

    // ----------------------------------------------------------
    // Tant qu'on reste dans le temps imparti
    while ($new_time - $start_time < $tempsExecMax && !feof($fsql))
    {
	$line="";
	while ((substr($line,strlen($line)-1,1)!="\n")&&(!feof($fsql))) {
		$line.=fgets($fsql,4096);
	}
	$line=rtrim($line);
	#echo "on traite $line<br>";
    $start=$start+1;
	if ($line!="") {
		if (substr($line,0,1)=="#") {
			$currentTable=substr($line,1);
			echo "</UL><BR><B>Restauration $currentTable</B><UL><BR>";
		} else {

			// affichage pour maintenir le navigateur en vie et faire patienter on affiche les commandes SQL
			if ($currentTable <> "infopages"  /* o il y a du HTML */  && ($start % 100)==0   ) {
				$portion=explode("values",$line);
				if ( count($portion) > 1 ){
					echo "<small><i>".$start." : ".substr($portion[1],0,150)."<br /></i></small>";flush();
				}
				else
				{
					echo "<small><i>".$start." : ".substr($line,0,150)."<br /></i></small>";flush();
				}
			}


			if (!mysql_query($line)) 
			{
			echo "<FONT COLOR=\"red\" >";
			print "<br><b>ERREUR ligne $start, ".mysql_error()." (code ".mysql_errno().") pour la requte : </b><small><i>".$line."</i></small><br><br>";
			echo "</FONT>";
			$cmd = "insert into PGS_suivi_restauration (quand,message,ligne,commande)  values (now(), \"".mysql_error()." (code ".mysql_errno().")\",$start,\"".str_replace("\\\"\"","\\\"",str_replace("\"","\"\"",$line))."\")";
			mysql_query($cmd) or die(mysql_error()." sur commande : ".$cmd."<br>"); 

			}
			flush(); 

		}

	}




    // ----------------------------------------------------------
    // Temps d'excution de la page
    list($usec, $sec) = explode(" ", microtime());
    $new_time=(float)$usec + (float)$sec;
    }

	// Traitement de fin
	if (feof($fsql) /* pour simule fin || $start > 20000 */ )
	{
		// On a fini le fichier de commandes : on ferme proprement et on le dtruit (c'est un fichier temporaire)
		fclose($fsql);
		@unlink($tempfiledest);

		/* Succeed - Gestion du cas particulier :
		* Dernire sauvegarde effectue <=> sauv_log_succeed valoris  1 aprs sauvegarde
		* Lors de la restauration, on rcupre la valeur 0, enregistre avant la fin de la sauvegarde.
		*/
		$requete="update sauv_log set sauv_log_succeed=1 where sauv_log_id=".$logid;
		@mysql_query($requete);

		// if ($critical==1) unlink($filename);
		$start = -1;
				
		$cmd="SELECT `quand` , `message`, `ligne` ,  `commande`   FROM 	PGS_suivi_restauration where message not like \"%itration%\";";
		$sql=mysql_query($cmd) or die(sprintf("Erreur sur commande %s\n",$cmd)); flush();
		echo "</UL><br><br><br><h2>Sauvegarde termine.</h2><br><br>";
		echo "<TABLE BORDER=\"1\">";
	
		echo"<CAPTION><FONT COLOR=\"red\" ><b>Table des vnements</b></FONT></CAPTION>"; 
		while ($row = mysql_fetch_array($sql)) {
			echo "<TR>";
			echo "<TD><FONT COLOR=\"red\" >$row[0]</FONT></TD>";
			echo "<TD><FONT COLOR=\"red\" >$row[1]</FONT></TD>";
			echo "<TD><FONT COLOR=\"red\" >$row[2]</FONT></TD>";
			echo "<TD><FONT COLOR=\"red\" >$row[3]</FONT></TD>";
			echo "<TR>";
		}
		echo "</TABLE><br>";
		

	}
	else
	{
		 $cmd = "insert into PGS_suivi_restauration (quand,message,ligne,commande)  values (now(),\"Fin itration $iteration\" ,$start,\"".str_replace("\\\"\"","\\\"",str_replace("\"","\"\"",$line))."\")";
		 mysql_query($cmd) or die(mysql_error()." sur commande : ".$cmd."<br>"); 

	
		// On ferme le fichier
		fclose($fsql);	
	}
	// On ferme la connexion  la base
			mysql_close($identifiant);
}





///////////////////////////////////////////////////////////////////////////////
/////////////////////// RELANCER LE SCRIPT ////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

if ($start > -1)
{
	echo "</UL><br><h2>Fin de l'itration n$iteration : attente de $tempsRepos millisecondes avant la reprise de l'excution  la ligne ".($start+1)."</h2><br><br>";

	print "
	<form class='form-$current_module' name='current_state' action='".$_SERVER["PHP_SELF"]."' method='post'>
	<input type='hidden' name='iteration'   value=\"$iteration\">
	<input type='hidden' name='start'       value=\"$start\">
	<input type='hidden' name='host'        value=\"$host\">
	<input type='hidden' name='db'          value=\"$db\">
	<input type='hidden' name='db_user'     value=\"$db_user\">
	<input type='hidden' name='db_password' value=\"$db_password\">
	</form>
	<script type=\"text/javascript\"><!--
	setTimeout(\"document.forms['current_state'].submit()\",$tempsRepos);
	-->
	</script>";
}
  ?>

